%%% Algorithm: http://en.wikipedia.org/wiki/Quicksort
%%% To build: Execute c(quicksort). command in an Erlang shell
%%% To run: Execute quicksort:sort([1,2,100,-1,alma]). command in the same shell

-module(quicksort).
-author("Viktória Fördős").
-export([sort/1]).

% Function clause for the empty list case
sort([])->
    [];
% Function clause for the other cases
sort([Y|List])->
    % Sort function is called recursively for those inputs 
    % which are less then or equal to the head of the input list
    % then the result is concated to 
    sort([X || X <- List, X =< Y]) ++ 
    % a list which has only one elem: the head elem (Y).
    % Next, the new result is concated to
    [Y] ++
    % the result of the following function call.
    % Sort function is called recursively for those inputs 
    % which are greater then to the head of the input list.
    % The result of the concatenation will be the result of the function.
    sort([X || X <- List, X > Y]).    